//"intezkfk.sci","Integracja ZK do FK - include",12016,0,1.0.0,SYSTEM
//"Integracja z FK-a",12015,14,62
/////////////////////////////////////////
// "Integracja ZK do FK - include"
// intezkfk.sci
/////////////////////////////////////////

// dostpne opcje wywoania fukcji IntegrortZK()
#define ROWNOLEGLE_KSIEG_MAG		0x1
#define NIE_INTE_OZNAK				0x2
record	TestRej
	int Rej
	int Typ
endrec

#include "Integracja ZK do FK - include2"
#include "Integracja ZK do FK - include3"

//---------------------------------------------------------------------------
int Sub IntegrZK(long idDK, int iOpcje)
//---------------------------------------------------------------------------
// zmienne globalne: BaseDK basDK, BaseDP basDP, InfoVat StVat(6)

	IntegrZK = 0

	Int    iCheckWL, iForceSP, iSplitPayment
	String sValue
	string sTyp, sFKDok, strRej
	int err
	int bKorekta = 0, bRozliczony, bZnaleziony
	int nCount = 1
	int nPozycja = 0
	int iStVat, iVat50, nRes
	int iRejVat, iPom,iPom2
	int index = 1

	nLastZap = 0

	String strOkres
	float dKwota, dKurs, dKwotaWal, dKursDoch
	float nettoNP, vatNP, wnettoNP, wbruttoNP
	
	String strTmp, strTmp2
	int iSubtyp
	int iRok

	string sRej, sRej2, sRejestry
	string strRex = "{*}naliczonyNP/={(:z)}{*}"

	long lSuper
	long lABC
	string sData
	string symbolFK, obslugujJak
	BaseZZ basZZ
	TestRej TabTestRej(1)
	int IDFK_K

	strOpis = ""

	if basDK.GetRecById(idDK) then error "Brak takiego rekordu w bazie DK"

	sData = basDK.GetField("datawp")
	iRok = Val(Mid(sData,1,4))
	if (iRok == 0) then error "Nieprawidowa data wpywu dokumentu"

	// sprawdzamy typ dokumentu
	iSubtyp = basDK.GetField("subtypi")
	Select Case iSubtyp
		Case FVZ, FKZ, RUZ, RKZ, DIM, DKM, FVR, FKR, ZRZ, ZRK , FVM, FKM, FZZ, ZKZ, WNT, FWZ, WKZ, WNK, ZVW, ZWK
		Case Else
			IntegrZK = 1 // pomijamy
			AddError("Nie mona wysa dokumentu " + basDK.GetField("kod") + ".",idDK)
	EndSelect
	if ( IntegrZK == 1 ) then Exit

	if CzyIntegrBrakSchematu(basDK.GetField("schemat"), basDK.GetField("kod"), idDK) then
		IntegrZK = 1 // pomijamy
		Exit
	endif

	if CzyIntegrBlednySchemat(basDK.GetField("schemat"), basDK.GetField("kod"), basDK.GetField("subtypi"), idDK) then
		IntegrZK = 1 // pomijamy
		Exit
	endif

	if 0 != basDK.GetField("khid") then
		if basKH.GetRecById(basDK.GetField("khid")) then error "Brak takiego rekordu w bazie KH"
		IntegrZK = CzyIntegrBrakIDFK(basKH.GetField("idfk"), basDK.GetField("kod"), idDK)
		if IntegrZK then exit
	endif

	sTyp = basDK.GetField("typ_dk")
	if (basDK.GetField("exp_fki")&FDK_IMPORT) then
		basXT.SetKey("kod")
		basXT.SetKeySeg("typi", XTustaDOK)
		basXT.SetKeySeg("kod", basDK.GetField("typ_dk"))
		err = basXT.GetRec(GE)
		sTyp = ""
		while !err && basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") != basDK.GetField("typ_dk") && basXT.GetField("long") != basDK.GetField("subtypi")
			err = basXT.GetRec(NX)
		wend
		if basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") == basDK.GetField("typ_dk") && basXT.GetField("long") == basDK.GetField("subtypi") then
			sTyp = basDK.GetField("typ_dk")
		else
			basXT.SetKey("kod")
			basXT.SetKeySeg("typi", XTustaDOK)
			basXT.SetKeySeg("kod", TypDOK(basDK.GetField("subtypi")))
			err = basXT.GetRec(GE)
			while !err && basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") != TypDOK(basDK.GetField("subtypi")) && basXT.GetField("long") != basDK.GetField("subtypi")
				err = basXT.GetRec(NX)
			wend
			if basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") == TypDOK(basDK.GetField("subtypi")) && basXT.GetField("long") == basDK.GetField("subtypi") then
				sTyp = TypDOK(basDK.GetField("subtypi"))
			else
				IntegrZK = CzyIntegrBrakTypDK("", basDK.GetField("kod"), idDK, TypDOK(basDK.GetField("subtypi")))
			endif
		endif
	endif

	basDK2.SetKey("numer")
	basDK2.SetKeySeg("typi", 101)	// KARTAdkTYP
	basDK2.SetKeySeg("kod",  sTyp)
	if basDK2.GetRec(EQ)  then error "Brak takiego rekordu w bazie DK"
	symbolFK = basDK2.GetField("khadres")
	obslugujJak = basDK2.GetField("khkodpocz")
	sRejestry = basDK2.GetField("odnazwa")

	//  na podstawie definicji typu dokumentu w FK okrelimy rok, do ktorego trafi dokument
	iRok = GetRokwFK(symbolFK, 0)
	if(iRok < 0) then 
		IntegrZK = iRok
		if (iRok == -1) then IntegrZK = 1 //pomin
		exit
	endif

	if RokFK(1).Zap == 1 then
		if RokFK(1).IdRok != iRok then
			UstawRok(iRok)
		endif
	else
		UstawRok(iRok)		
	endif
	dst=RokFK(1).Rok
	plkn=RokFK(1).PlanKont
	defdok=RokFK(1).DefDokument
	defrej = RokFK(1).DefRejestr

	if !(basDK.GetField("exp_fki")&FDK_IMPORT) || ((basDK.GetField("exp_fki")&FDK_IMPORT) && sTyp != "") then	
		IntegrZK = CzyIntegrBrakTypDK(basDK2.GetField("khadres"), basDK.GetField("kod"), idDK, sTyp)
	endif
	if IntegrZK then exit
	
	dKurs = basDK.GetField("kurs")
	dKursDoch = basDK.GetField("kursDoch")

	//sprawdzamy czy faktury walutowe nie sa eksportowane jako stare( nie walutowe) do FK
	if(iSubtyp == FVW || iSubtyp == FKW)  && (obslugujJak != "FWZ" && obslugujJak != "FWZK") && (dKurs != dKursDoch) then
		nRes = 1
	else
		nRes = 0
	endif		
	if  !CzyIntegrBlednyTypFK(nRes, basDK.GetField("kod")) then //!dokanul &&
		IntegrZK = 0 // pomijamy
		Exit
	endif

	iSubtyp = basDK.GetField("subtypi")
	Select Case iSubtyp
		Case FVZ, FKZ, RUZ, RKZ, DIM, DKM, FVR, FKR, ZRZ, ZRK, FVM, FKM, FZZ, ZKZ, WNT, FWZ, WKZ, WNK
			basDP.SetKey("super")
			basDP.SetKeySeg("super", idDK)
			err = basDP.GetRec(GE)
			while !err && basDP.GetKeySeg("super") == idDK
				if !(basDP.GetField("flag") & BFLAGdpDOKOMPL) then
					iStVat = basDP.GetField("stvati")
					sRej = (using "%d",basDP.GetField("rejestrVati"))
					lSuper = 10700
					basXT.SetKey("super")
					basXT.SetKeySeg("super", lSuper)
					basXT.SetKeySeg("kod", "")
					basNT.SetKey("super")
					basNT.SetKeySeg("typi", 18)
					basNT.SetKeySeg("baza", 2)
					err = basXT.GetRec(GE)
					while !err && basXT.GetKeySeg("super") == lSuper					
						strTmp = Using "%l", basXT.GetField("long")							
						if sRej == strTmp then
							basNT.SetKeySeg("super", basXT.GetField("id"))
							if !basNT.GetRec(EQ) then
								buf = basNT.GetField("opis")
								move 0
								find "\$\$"
								strRej = mid(buf,1,(move 0)-1)
								if strRej != "" && strRej != "0" && !defrej.MoveTo(strRej) then
									IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
								else
									IntegrZK = CzyintegrBlednyRej(strRej, basDK.GetField("kod"), idDK)							
									TabTestRej(size(TabTestRej)).Rej = val(mid(buf,1,(move 0)-1))
									TabTestRej(size(TabTestRej)).Typ = basXT.GetField("zawartosc")
									grow TabTestRej,1
								endif
							else
								IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
							endif
							exit // wyjcie z ptli
						endif
						err = basXT.GetRec(NX)
					wend
					if (iSubtyp == FWZ || iSubtyp == WKZ) then
						iStVat = basDP.GetField("stvati")
						sRej = (using "%d",basDP.GetField("rejestrVat2"))
						lSuper = 10500
						basXT.SetKey("super")
						basXT.SetKeySeg("super", lSuper)
						basXT.SetKeySeg("kod", "")
						basNT.SetKey("super")
						basNT.SetKeySeg("typi", 18)
						basNT.SetKeySeg("baza", 2)
						err = basXT.GetRec(GE)
						bZnaleziony = 0
						while !err && basXT.GetKeySeg("super") == lSuper					
							strTmp = Using "%l", basXT.GetField("long")							
							if sRej == strTmp then
								bZnaleziony = 1
								basNT.SetKeySeg("super", basXT.GetField("id"))
								if !basNT.GetRec(EQ) then
									buf = basNT.GetField("opis")
									move 0
									find "\$\$"
									strRej = mid(buf,1,(move 0)-1)
									if strRej != "" && strRej != "0" && !defrej.MoveTo(strRej) then
										IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
									else
										IntegrZK = CzyintegrBlednyRej(strRej, basDK.GetField("kod"), idDK)							
										TabTestRej(size(TabTestRej)).Rej = val(mid(buf,1,(move 0)-1))
										TabTestRej(size(TabTestRej)).Typ = basXT.GetField("zawartosc")
										grow TabTestRej,1
									endif
								else
									IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
								endif
								exit // wyjcie z ptli
							endif
							err = basXT.GetRec(NX)
						wend
						if !bZnaleziony then
							IntegrZK = CzyintegrBrakRej(1, basDK.GetField("kod"), idDK)
							if IntegrZK then exit
						endif
					endif
					if (iSubtyp == FWZ || iSubtyp == FVZ || iSubtyp == ZVW || iSubtyp == ZWK) then
						iVat50 = basDP.GetField("vat50")
						if (iVat50) then
							buf = sRejestry
							if find regular strRex then sRej = regular 2
							lSuper = 10700
							basXT.SetKey("super")
							basXT.SetKeySeg("super", lSuper)
							basXT.SetKeySeg("kod", "")
							basNT.SetKey("super")
							basNT.SetKeySeg("typi", 18)
							basNT.SetKeySeg("baza", 2)
							err = basXT.GetRec(GE)
							bZnaleziony = 0
							while !err && basXT.GetKeySeg("super") == lSuper					
								strTmp = Using "%l", basXT.GetField("long")							
								if sRej == strTmp then
									bZnaleziony = 1
									basNT.SetKeySeg("super", basXT.GetField("id"))
									if !basNT.GetRec(EQ) then
										buf = basNT.GetField("opis")
										move 0
										find "\$\$"
										strRej = mid(buf,1,(move 0)-1)
										if strRej != "" && strRej != "0" && !defrej.MoveTo(strRej) then
											IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
										else
											IntegrZK = CzyintegrBlednyRej(strRej, basDK.GetField("kod"), idDK)							
											TabTestRej(size(TabTestRej)).Rej = val(mid(buf,1,(move 0)-1))
											TabTestRej(size(TabTestRej)).Typ = basXT.GetField("zawartosc")
											grow TabTestRej,1
										endif
									else
										IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
									endif
									exit // wyjcie z ptli
								endif
								err = basXT.GetRec(NX)
							wend
							if !bZnaleziony then
								IntegrZK = CzyintegrBrakRej(1, basDK.GetField("kod"), idDK)
								if IntegrZK then exit
							endif
						endif
					endif
					if (iSubtyp == DIM || iSubtyp == DKM || iSubtyp == FVZ || iSubtyp == FKZ) then
						iStVat = basDP.GetField("stvati")
						sRej2 = (using "%d",basDP.GetField("rejestrVat2"))
						if !(sRej2 == "255") then
							lSuper = 10500
							basXT.SetKey("super")
							basXT.SetKeySeg("super", lSuper)
							basXT.SetKeySeg("kod", "")
							basNT.SetKey("super")
							basNT.SetKeySeg("typi", 18)
							basNT.SetKeySeg("baza", 2)
							err = basXT.GetRec(GE)
							bZnaleziony = 0
							while !err && basXT.GetKeySeg("super") == lSuper					
								strTmp2 = Using "%l", basXT.GetField("long")							
								if sRej2 == strTmp2 then
									bZnaleziony = 1
									basNT.SetKeySeg("super", basXT.GetField("id"))
									if !basNT.GetRec(EQ) then
										buf = basNT.GetField("opis")
										move 0
										find "\$\$"
										strRej = mid(buf,1,(move 0)-1)
										if strRej != "" && strRej != "0" && !defrej.MoveTo(strRej) then
											IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
										else
											IntegrZK = CzyintegrBlednyRej(strRej, basDK.GetField("kod"), idDK)		
											TabTestRej(size(TabTestRej)).Rej = val(mid(buf,1,(move 0)-1))
											TabTestRej(size(TabTestRej)).Typ = basXT.GetField("zawartosc")
											grow TabTestRej,1
										endif
									else
										IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
									endif
									exit
								endif
								err = basXT.GetRec(NX)
							wend
							if !bZnaleziony then
								IntegrZK = CzyintegrBrakRej(1, basDK.GetField("kod"), idDK)
								if IntegrZK then exit
							endif
						endif
					endif
					if IntegrZK then exit
				endif
				err = basDP.GetRec(NX)
				IntegrZK = CzyintegrBrakRej(iif(sRej == strTmp,0,1), basDK.GetField("kod"), idDK)
				if IntegrZK then exit
			wend
	endselect

	if IntegrZK then exit

	shrink TabTestRej,-1
	TabTestRej(1).Rej=-2000
	TabTestRej(1).Typ=-2000
	if IntegrZK then exit

	if ( basDK.GetField("iddokkoryg") ) then bKorekta = 1
	bRozliczony = basDK.GetField("oki")

	dst.Clear()
	sOpisy=0
	dbd.CurrentDate = sDataWpr

	//nie potrzeba adnych if-w poniewa zarwno
	//dokumenty wasne jak i obce maj w polu data_obcy waciw dat, czyli dat wystawienia dokumentu
	if ( basDK.GetField("subtypi") == FWZ || basDK.GetField("subtypi") == WKZ ) then
		strTmp = OdczytajDataObca( basDK.GetField("id"), basDK.GetField("subtypi") )
		dst.Value("DataDok") = strTmp
	else
		dst.Value("DataDok") = basDK.GetField("data_obcy")
	endif

		//opcje e_faktury
#ifndef LITE
		if CheckFieldExist(dst,  "eGUID") then dst.Value("eGUID") = basDK.GetField("guid") 
		if CheckFieldExist(dst,  "uid") then dst.Value("uid") = basDK.GetField("guid") 
		if CheckFieldExist(dst,  "eStatus") then dst.Value("eStatus") = basDK.GetField("e_status") 
#endif


	strTmp = basDK.GetField("datawp")
	dst.Value("Datawpl") = strTmp
	obl.Add(BAS_ZK, idDK)

	if basDK.GetField("subtypi") == FWZ || basDK.GetField("subtypi") == WKZ	|| basDK.GetField("subtypi") == DIM || basDK.GetField("subtypi") == DKM then
	//faktura wewntrzna zakupu i dokument importowy
		if ( basDK.GetField("subtypi") == FWZ || basDK.GetField("subtypi") == WKZ ) then
			strTmp = OdczytajDataZakup( basDK.GetField("id"), basDK.GetField("subtypi") )
			dst.Value("DataOper") = strTmp
		else
			dst.Value("DataOper") = basDK.GetField("data_obcy")		//jako data operacji gospodarczej wchodzi nasza data wystawienia
		endif
	else
		dst.Value("DataOper") = basDK.GetField("datasp")		//w pozostaych przypadkach nasza data zakupu
	endif

	dst.Value("Datawpr") = sDataWpr
	if basDK.GetField("khid") != 0 && !basKH.GetRecById(basDK.GetField("khid")) then
		dst.Value("kontrahent") = basKH.GetField("idfk")
	endif

	if firma.IsSymfoniaJedenZero == 0 then
		dst.Danekh.Value("Nazwa") = basDK.GetField("khnazwa")
		dst.DaneKh.Value("Nip") = basDK.GetField("khnip")
		dst.DaneKh.Value("Ulica") = basDK.GetField("khadres")
		dst.DaneKh.Value("Dom") = basDK.GetField("khdom")
		dst.DaneKh.Value("Lokal") = basDK.GetField("khlokal")
		dst.DaneKh.Value("Miejscowosc") = basDK.GetField("khmiasto")
		dst.DaneKh.Value("KodPocztowy") = basDK.GetField("khkodpocz")
		dst.DaneKh.Value("Kraj") = PoleKodKraju(basDK.GetField("idKraju"))
	endif

	if 0 == basDK.GetField("khid") && basDK.GetField("khnazwa") != "" then
		// kontrahent incydentalny sprawdzany i ewentualnie tworzony we wlasciwym roku
		kontrah.Open(dbd,8)
		kontrah.ClearRecord()
		kontrah.Value("nazwa") = basDK.GetField("khnazwa")
		kontrah.Value("nip") = basDK.GetField("khnip")
		kontrah.Value("ulica") = basDK.GetField("khadres")
		kontrah.Value("nrDomu") = basDK.GetField("khdom")
		kontrah.Value("nrMieszkania") = basDK.GetField("khlokal")
		kontrah.Value("miejscowosc") = basDK.GetField("khmiasto")
		kontrah.Value("kodPocztowy") = basDK.GetField("khkodpocz")
		
		IDFK_K = kontrah.CheckIfExists()
		if !IDFK_K then
			if kontrah.Validate() && (IntegrZK == 0) then
				if !kontrah.Insert() && kontrah.CheckIfExists() then
					if ItgInfo.Info("PlanKontSubjectType") then 
						dst.Value("kontrahent") = kontrah.GetExistingPoz(0)
					else
						dst.Value("kontrahent") = kontrah.GetExistingId(0)
					endif
				endif
			endif
		else
			if ItgInfo.Info("PlanKontSubjectType") then 
				dst.Value("kontrahent") = kontrah.GetExistingPoz(0)
			else
				dst.Value("kontrahent") = kontrah.GetExistingId(0)
			endif
		endif
	endif
	if 0 != basDK.GetField("khid") then
	endif
	if 0 != basDK.GetField("odid") then
	endif

	sValue = basDK.GetField("checkWL")
	iCheckWL = IIF(sValue == "T" || sValue == "t", 1, 0)
	sValue = basDK.GetField("splitPayment")
	iSplitPayment = IIF(sValue == "T" || sValue == "t", 1, 0)
	sValue = basDK.GetField("forceSP")
	iForceSP = IIF(sValue == "T" || sValue == "t", 1, 0)
	dst.Value("mppFlags") = iSplitPayment + 2 * iForceSP + 4 * iCheckWL
	dst.Value("accountNo") = basDK.GetField("account")
	dst.Value("JPK_V7") = basDK.GetField("JPK_V7")

	if basDK.GetField("subtypi") != DIM && basDK.GetField("subtypi") != DKM then
		dKwota = Round( ((-1)*(basDK.GetField("netto") + basDK.GetField("vat"))), 2 )
	else
		dKwota = Round( ((-1)*(basDK.GetField("netto"))), 2 )
	endif

	if CzyWalutowy(idDK) then
		dKurs = basDK.GetField("kurs")
		dst.Value("kurs") = dKurs
		dst.Value("waluta") = basDK.GetField("waluta")

		dKwotaWal = GetKwotaNaleznosciWal(idDK)
		dKwotaWal *= -1

		dst.Value("wkwota") = dKwotaWal
		dKwota = Round(dKwotaWal * dKurs, 2)
		dst.Value("Kwota") = dKwota
	else
		iSubtyp = basDK.GetField("subtypi")
		if iSubtyp == DIM || iSubtyp == DKM || iSubtyp == WNT || iSubtyp == WNK then
			// w tym wypadku dKwota zawiera ca, akcyzy i inne, a nie powinna

			dKwota = 0
			if obl.GetFirstZap() then
				Do
					if obl.StronaZap == "WN" then
						dKwota += obl.KwotaZap
					endif
				Loop While ( obl.GetNextZap() )
			endif

			dst.Value("Kwota") = dKwota
		else
//			dKwota = basDK.GetField("netto") + basDK.GetField("vat") to jest le bo bdzie kwota z minusem
			dst.Value("Kwota") = dKwota
		endif
	endif

	sTyp = basDK.GetField("typ_dk")
	if (basDK.GetField("exp_fki")&FDK_IMPORT) then
		basXT.SetKey("kod")
		basXT.SetKeySeg("typi", XTustaDOK)
		basXT.SetKeySeg("kod", basDK.GetField("typ_dk"))
		err = basXT.GetRec(GE)
		sTyp = ""
		while !err && basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") != basDK.GetField("typ_dk") && basXT.GetField("long") != basDK.GetField("subtypi")
			err = basXT.GetRec(NX)
		wend
		if basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") == basDK.GetField("typ_dk") && basXT.GetField("long") == basDK.GetField("subtypi") then
			sTyp = basDK.GetField("typ_dk")
		else
			basXT.SetKey("kod")
			basXT.SetKeySeg("typi", XTustaDOK)
			basXT.SetKeySeg("kod", TypDOK(basDK.GetField("subtypi")))
			err = basXT.GetRec(GE)
			while !err && basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") != TypDOK(basDK.GetField("subtypi")) && basXT.GetField("long") != basDK.GetField("subtypi")
				err = basXT.GetRec(NX)
			wend
			if basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") == TypDOK(basDK.GetField("subtypi")) && basXT.GetField("long") == basDK.GetField("subtypi") then
				sTyp = TypDOK(basDK.GetField("subtypi"))
			else
				error "Brak takiego rekordu w bazie DK"
			endif
		endif
	endif
	if !(basDK.GetField("exp_fki")&FDK_IMPORT) || ((basDK.GetField("exp_fki")&FDK_IMPORT) && sTyp != "") then
		basDK2.SetKey("numer")
		basDK2.SetKeySeg("typi", 101)	// KARTAdkTYP
		basDK2.SetKeySeg("kod",  sTyp)
		if basDK2.GetRec(EQ)  then error "Brak takiego rekordu w bazie DK"
	endif
	// "symbol FK" i "obsuguj jak"
	sFKDok = basDK2.GetField("khadres")
	dst.Value("skrot") = basDK2.GetField("khadres")

	// numer i data dokumentu korygowanego
	basDK2.GetRecById(basDK.GetField("iddokkoryg"))
	strTmp = OdczytajKodObcy( basDK2.GetField("id"), basDK2.GetField("subtypi"), basDK2.GetField("kod_obcy") )
	strTmp += " ["
	strTmp += basDK2.GetField("kod")
	strTmp += "]"
	strTmp = Mid(strTmp, 1, iif(len(strTmp)>LEN_NRDK,LEN_NRDK,len(strTmp)))
	dst.Value("NazwaKor") = strTmp
	dst.Value("DataKor") = basDK2.GetField("datasp")

	if(	CzyWalutowy(idDK) && (obslugujJak == "FWZ" || obslugujJak == "FWZK"))  then //&& czyPozycjaVAT then //nowy typ dokumentu w FK - wielowalutowy
	dst.RejestrVAT.PozycjaVAT.MoveKursVAT()
		dst.RejestrVAT.PozycjaVAT.Value("TypExt") = 1
		dst.RejestrVAT.PozycjaVAT.Value("Nazwa") = basDK.GetField("waluta")
		dst.RejestrVAT.PozycjaVAT.Value("Wartosc") = dKurs

		dst.RejestrVAT.PozycjaVAT.MoveKursCITPIT()
		dst.RejestrVAT.PozycjaVAT.Value("TypExt") = 2
		dst.RejestrVAT.PozycjaVAT.Value("Nazwa") = basDK.GetField("waluta")
		dst.RejestrVAT.PozycjaVAT.Value("Wartosc") = dKursDoch
	endif

	// pozycje dokumentu
	basDP.SetKey("super")
	basDP.SetKeySeg("super", idDK)
	err = basDP.GetRec(GE)
	while !err && basDP.GetKeySeg("super") == idDK
		iStVat = basDP.GetField("stvati")
		sRej = (using "%d",basDP.GetField("rejestrVati"))
		lSuper = 10700
		iRejVat=-2000
		strTmp = PoleRejestrFK(lSuper, Val(sRej), '\n')
		iRejVat = Val(GetNthElement(1, strTmp, '\n'))
		lABC = Val(GetNthElement(2, strTmp, '\n'))
		if !CzyStNP(basDP.GetField("stvati")) then 
			if basDP.GetField("vat50") then
				nettoNP = Round(basDP.GetField("wartNetto")/ 2)
				vatNP = Round(basDP.GetField("wartVat")/ 2)
				wnettoNP = Round(basDP.GetField("walNetto") /2)
				wbruttoNP = Round(basDP.GetField("walBrutto") / 2)
				TabRejVat.Wstaw(iRejVat,iStVat, basDP.GetField("wartNetto")-nettoNP, basDP.GetField("wartVat")-vatNP, 0, basDP.GetField("walNetto")-wnettoNP, basDP.GetField("walBrutto")-wbruttoNP,lABC, 0, basDP.GetField("JPK_V7"))
				buf = sRejestry
				if find regular strRex then 
					sRej = regular 2
					lSuper = 10700
					strTmp = PoleRejestrFK(lSuper, Val(sRej), '\n')
					iRejVat = Val(GetNthElement(1, strTmp, '\n'))
					lABC = Val(GetNthElement(2, strTmp, '\n'))
					iStVat = StawkaNP()
					TabRejVat.Wstaw(iRejVat,iStVat, 0, 0, nettoNP+vatNP, wbruttoNP, wbruttoNP, lABC, 0, basDP.GetField("JPK_V7"))
				endif
			else
			TabRejVat.Wstaw(iRejVat,iStVat, basDP.GetField("wartNetto"), basDP.GetField("wartVat"), 0, basDP.GetField("walNetto"), basDP.GetField("walBrutto"),lABC, 0, basDP.GetField("JPK_V7"))
			endif
		else
			TabRejVat.Wstaw(iRejVat,iStVat, 0, 0, basDP.GetField("wartNetto"),basDP.GetField("walNetto"), basDP.GetField("walBrutto"),lABC, 0, basDP.GetField("JPK_V7"))
		endif

		if  iSubtyp == FWZ || iSubtyp == WKZ || iSubtyp == DIM || iSubtyp == DKM || iSubtyp == FVZ || iSubtyp == FKZ then
			iStVat = basDP.GetField("stvati")
			sRej = (using "%d",basDP.GetField("rejestrVat2"))
			if !(sRej == "255") then
				lSuper = 10500
				iRejVat=-2000
				strTmp = PoleRejestrFK(lSuper, Val(sRej), '\n')
				if strTmp != "" then
					iRejVat = Val(GetNthElement(1, strTmp, '\n'))
					lABC = Val(GetNthElement(2, strTmp, '\n'))
				if !CzyStNP(basDP.GetField("stvati")) then 
					TabRejVat.Wstaw(iRejVat,iStVat, basDP.GetField("wartNetto"), basDP.GetField("wartVat"), 0,basDP.GetField("walNetto"), basDP.GetField("walBrutto"),lABC, 1, basDP.GetField("JPK_V7"))
				else
					TabRejVat.Wstaw(iRejVat,iStVat, 0, 0, basDP.GetField("wartNetto"),basDP.GetField("walNetto"), basDP.GetField("walBrutto"),lABC, 1, basDP.GetField("JPK_V7"))
				endif
			endif
		endif
		endif
		DodajDoOpisu(basDP.GetField("opis"), "/")
		err = basDP.GetRec(NX)
	wend

	//////////////////////////////////////////////////////
	// numer dokumentu w FK
	strTmp = OdczytajKodObcy( basDK.GetField("id"), basDK.GetField("subtypi"), basDK.GetField("kod_obcy") )
	strTmp += " ["
	strTmp += basDK.GetField("kod")
	strTmp += "]"
	strTmp = Mid(strTmp, 1, iif(len(strTmp)>LEN_NRDK, LEN_NRDK, len(strTmp)))
	dst.Value("nazwa") = strTmp

	dst.Value("tresc")	= obl.Tresc  //opis fk

	nLastZap = ZapiszZAP(obl, 0, 0, basDK.GetField("oki"), basDK.GetField("plattermin"), CzyWalutowy(idDK), basDK.GetField("waluta"))


	ZapiszETRANSFERS(idDK, obl)

	// rwnolege ksigowania magazynowe
	if iOpcje & ROWNOLEGLE_KSIEG_MAG then
		nCount += 1

		//jezeli jest to faktura wewnetrzna
		if iSubTyp == FWZ || iSubTyp == WKZ then
			lSuper = VAL(basDK.GetField("odebrane"))
			if lSuper then			//szukamy dok magazynowego

				if ( basZZ.Open() ) then error "Bd otwarcia bazy ZZ"

				basZZ.SetKey("cross1")
				basZZ.SetKeySeg("typi", 151)			
				basZZ.SetKeySeg("baza1", 34)		// baza
				basZZ.SetKeySeg("id1",   idDK)			// id 
				basZZ.SetKeySeg("baza2", 33)

				err = basZZ.GetRec(GE)
				if !err && basZZ.GetKeySeg("typi") == 151 && basZZ.GetKeySeg("baza1") == 34 && basZZ.GetKeySeg("id1") == idDK && basZZ.GetKeySeg("baza2") == 33 then
					basMG.SetKey("id")
					basMG.SetKeySeg("id", basZZ.GetKeySeg("id2"))	
					if !basMG.GetRec(EQ) then
						if ( iOpcje & NIE_INTE_OZNAK && (basMG.GetField("exp_fki") & 0x01) ) then
							eksport.AddInfo("Nie mona powtrnie wysa zapisw do dokumentu " + basMG.GetField("kod") + ".")
						else
							if !IntegrZatwWart(basMZ, basPW, basMG.GetField("id"), basMG.GetField("kod"), basDK.GetField("kod")) then	
								obl.Add(BAS_MG, basMG.GetField("id"))
								if(obslugujJak == "FWZ" || obslugujJak == "FWZK")  then //nowy typ dokumentu w FK - wielowalutowy
								//ewentualne rownolegle ksiegowanie magazynowe tylko w PLN
									nLastZap = ZapiszZAP(obl, 1, nLastZap, 0, basMG.GetField("termin"), 0, "")
								else
									nLastZap = ZapiszZAP(obl, 1, nLastZap, 0, basMG.GetField("termin"), CzyWalutowy(idDK), basDK.GetField("waluta"))
								endif
								MgId = basMG.GetField("id")
							endif
						endif
					endif
				endif
				basZZ.close()
			endif
		else
			// dokumenty magazynowe rozliczajce dokument handlowy
			basMG.SetKey("idhandl")
			basMG.SetKeySeg("idhandl", idDK)
			err = basMG.GetRec(GE)
			while !err && basMG.GetKeySeg("idhandl") == idDK
				if ( iOpcje & NIE_INTE_OZNAK && (basMG.GetField("exp_fki") & 0x01) ) then
					eksport.AddInfo("Nie mona powtrnie wysa zapisw do dokumentu " + basMG.GetField("kod") + ".")
				else
					if !IntegrZatwWart(basMZ, basPW, basMG.GetField("id"), basMG.GetField("kod"), basDK.GetField("kod")) then	
						obl.Add(BAS_MG, basMG.GetField("id"))
						if(obslugujJak == "FWZ" || obslugujJak == "FWZK")  then //nowy typ dokumentu w FK - wielowalutowy
						//ewentualne rownolegle ksiegowanie magazynowe tylko w PLN
							nLastZap = ZapiszZAP(obl, 1, nLastZap, 0, basMG.GetField("termin"), 0, "")
						else
							nLastZap = ZapiszZAP(obl, 1, nLastZap, 0, basMG.GetField("termin"), CzyWalutowy(idDK), basDK.GetField("waluta"))
						endif
					endif
				endif

				err = basMG.GetRec(NX)
			wend
		endif
	endif // rwnolege ksigowania magazynowe

	// rejestry VAT
	if sFKDok != "DP" then
		RejestryVAT(idDK, CzyWalutowy(idDK))
	endif
	obl.Clear()

	//DIM jest wielowalutowy, wiec czyscimy dla dokumentu walutowosc
	//if iSubtyp == DIM || iSubtyp == DKM || iSubtyp == ZVW || iSubtyp == ZWK then
	//ten warunek powinien by nie na typ dokumentu, tylko na to jak on jest obslugiwany
	if obslugujJak == "DIM" || obslugujJak == "FWZ" || obslugujJak == "FWZK" then
		dst.Value("waluta") = ""
		dKurs = 0
		dst.Value("kurs") = dKurs
		dKwotaWal = 0
		dst.Value("wkwota") = dKwotaWal
	endif	

	dst.Validate()
	if (ers.Count) then IntegrZK = ShowError(basDK.GetField("nazwa")+" "+basDK.GetField("kod"))
	if IntegrZK == 0 then IntegrZK = !dst.Insert()
	ShowStatus(basDK.GetField("kod"),idDK, IntegrZK)

EndSub

//---------------------------------------------------------------------------
int Sub BeginProcessZK()
//---------------------------------------------------------------------------
	int iVal

	//////////////////////////
	// otwarcie baz 
	if ( basKH.Open() ) then error "Bd otwarcia bazy KH"
	if ( basXT.Open() ) then error "Bd otwarcia bazy XT"
	if ( basTW.Open() ) then error "Bd otwarcia bazy TW"
	if ( basDK.Open() ) then error "Bd otwarcia bazy DK"
	if ( basDK2.Open() ) then error "Bd otwarcia bazy DK"
	if ( basDP.Open() ) then error "Bd otwarcia bazy DP"
	if ( basMG.Open() ) then error "Bd otwarcia bazy MG"
	if ( basMZ.Open() ) then error "Bd otwarcia bazy MZ"
	if ( basPW.Open() ) then error "Bd otwarcia bazy PW"
	if ( basNT.Open() ) then error "Bd otwarcia bazy NT"

	TabRejVat.ClearRec()
EndSub

//---------------------------------------------------------------------------
int Sub DoProcessZK(long idDK)
//---------------------------------------------------------------------------
	DoProcessZK = 0

	int iVal, err
	int iOpcje = 0

	if basDK.GetRecById(idDK) then error "Brak takiego rekordu w bazie DK"

	if ( iNieIntegrOznak && (basDK.GetField("exp_fki") & 0x01) ) then
		DoProcessZK = 1 // pomijamy
			AddError("Nie mona powtrnie wysa dokumentu " + basDK.GetField("kod") + ".",idDK)
		Exit // nie wysylamy oznakowanych dokumentw
	endif

	if ( iNieIntegrOznak ) then iOpcje |= NIE_INTE_OZNAK

	// czy rwnolege ksigowanie magazynowe
	if ( iRownoKsiegMag ) then iOpcje |= ROWNOLEGLE_KSIEG_MAG

	TabRejVat.ClearRec()
	MgId = 0

	DoProcessZK = IntegrZK(idDK, iOpcje)
	if	DoProcessZK then Exit	 // pomijamy

	/////////////////////////////////////////////////
	// oznaczamy wyslany dokument
	if ( iOznaczaj ) then
		iVal = basDK.GetField("exp_fki")
		iVal |= 0x01
		basDK.SetField("exp_fki", iVal)
		basDK.Update()

		// dokumenty magazynowe rozliczajce dokument handlowy
		if ( iRownoKsiegMag ) then
			if MgId then
				basMG.SetKey("id")
				basMG.SetKeySeg("id", MgId)
				if !basMG.GetRec(EQ) then
					iVal = basMG.GetField("exp_fki")
					iVal |= 0x01
					basMG.SetField("exp_fki", iVal)
					basMG.Update()
				endif
			else
				basMG.SetKey("idhandl")
				basMG.SetKeySeg("idhandl", idDK)
				err = basMG.GetRec(GE)
				while !err && basMG.GetKeySeg("idhandl") == idDK
					iVal = basMG.GetField("exp_fki")
					iVal |= 0x01
					basMG.SetField("exp_fki", iVal)
					basMG.Update()
					err = basMG.GetRec(NX)
				wend
			endif
		endif
	endif
EndSub

//---------------------
int Sub EndProcessZK()
//---------------------
	basKH.close()
	basXT.close()
	basTW.close()
	basDK.close()
	basDK2.close()
	basDP.close()
	basMG.close()
	basMZ.close()
	basPW.close()
	basNT.close()
EndSub